﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;

namespace Sage200ThreadLogon
{
    /// <summary>
    /// Please note this project currently targets Sage2010 assemblies.
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            //Start the manager otherwise nothing will print!
            ReportQueueManager.Start();
            
            //Create two threads to test concurrent printing.
            Connector connector1 = new Connector(1);
            Thread t1 = new Thread(new ParameterizedThreadStart(connector1.StartThread));
            t1.SetApartmentState(ApartmentState.MTA);
            
            Connector connector2 = new Connector(2);
            Thread t2 = new Thread(new ParameterizedThreadStart(connector2.StartThread));
            t2.SetApartmentState(ApartmentState.MTA);

            //Start the first then create the second a moment later.
            t1.Start(true);
            Thread.Sleep(100);
            t2.Start(false);

            //Wait for both to finish.
            t1.Join();
            t2.Join();

            //Shutdown the manager gracefully.
            ReportQueueManager.Shutdown();
        }
    }
}
